// Code generated by protoc-gen-go-grpc. DO NOT EDIT.

package freeje_admin

import (
	context "context"
	api "gitlab.com/BetaCompany/Freeje/sdk/go/api"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

// CoverageClient is the client API for Coverage service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type CoverageClient interface {
	//
	// Получить список номерного покрытия
	List(ctx context.Context, in *api.SearchFilter, opts ...grpc.CallOption) (Coverage_ListClient, error)
	//
	// Получить актуальнае данные покрытия по полю префикса
	Get(ctx context.Context, in *CoverageArea, opts ...grpc.CallOption) (*CoverageArea, error)
	//
	// Обновление омформации о покрытии. (Поле country вычисляется автоматически и должно передаваться пустым, в случае deleted=true префикс удаляется)
	Update(ctx context.Context, in *CoverageArea, opts ...grpc.CallOption) (*CoverageArea, error)
}

type coverageClient struct {
	cc grpc.ClientConnInterface
}

func NewCoverageClient(cc grpc.ClientConnInterface) CoverageClient {
	return &coverageClient{cc}
}

func (c *coverageClient) List(ctx context.Context, in *api.SearchFilter, opts ...grpc.CallOption) (Coverage_ListClient, error) {
	stream, err := c.cc.NewStream(ctx, &Coverage_ServiceDesc.Streams[0], "/com.freeje.api.admin.Coverage/List", opts...)
	if err != nil {
		return nil, err
	}
	x := &coverageListClient{stream}
	if err := x.ClientStream.SendMsg(in); err != nil {
		return nil, err
	}
	if err := x.ClientStream.CloseSend(); err != nil {
		return nil, err
	}
	return x, nil
}

type Coverage_ListClient interface {
	Recv() (*CoverageArea, error)
	grpc.ClientStream
}

type coverageListClient struct {
	grpc.ClientStream
}

func (x *coverageListClient) Recv() (*CoverageArea, error) {
	m := new(CoverageArea)
	if err := x.ClientStream.RecvMsg(m); err != nil {
		return nil, err
	}
	return m, nil
}

func (c *coverageClient) Get(ctx context.Context, in *CoverageArea, opts ...grpc.CallOption) (*CoverageArea, error) {
	out := new(CoverageArea)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Coverage/Get", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *coverageClient) Update(ctx context.Context, in *CoverageArea, opts ...grpc.CallOption) (*CoverageArea, error) {
	out := new(CoverageArea)
	err := c.cc.Invoke(ctx, "/com.freeje.api.admin.Coverage/Update", in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// CoverageServer is the server API for Coverage service.
// All implementations should embed UnimplementedCoverageServer
// for forward compatibility
type CoverageServer interface {
	//
	// Получить список номерного покрытия
	List(*api.SearchFilter, Coverage_ListServer) error
	//
	// Получить актуальнае данные покрытия по полю префикса
	Get(context.Context, *CoverageArea) (*CoverageArea, error)
	//
	// Обновление омформации о покрытии. (Поле country вычисляется автоматически и должно передаваться пустым, в случае deleted=true префикс удаляется)
	Update(context.Context, *CoverageArea) (*CoverageArea, error)
}

// UnimplementedCoverageServer should be embedded to have forward compatible implementations.
type UnimplementedCoverageServer struct {
}

func (UnimplementedCoverageServer) List(*api.SearchFilter, Coverage_ListServer) error {
	return status.Errorf(codes.Unimplemented, "method List not implemented")
}
func (UnimplementedCoverageServer) Get(context.Context, *CoverageArea) (*CoverageArea, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Get not implemented")
}
func (UnimplementedCoverageServer) Update(context.Context, *CoverageArea) (*CoverageArea, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Update not implemented")
}

// UnsafeCoverageServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to CoverageServer will
// result in compilation errors.
type UnsafeCoverageServer interface {
	mustEmbedUnimplementedCoverageServer()
}

func RegisterCoverageServer(s grpc.ServiceRegistrar, srv CoverageServer) {
	s.RegisterService(&Coverage_ServiceDesc, srv)
}

func _Coverage_List_Handler(srv interface{}, stream grpc.ServerStream) error {
	m := new(api.SearchFilter)
	if err := stream.RecvMsg(m); err != nil {
		return err
	}
	return srv.(CoverageServer).List(m, &coverageListServer{stream})
}

type Coverage_ListServer interface {
	Send(*CoverageArea) error
	grpc.ServerStream
}

type coverageListServer struct {
	grpc.ServerStream
}

func (x *coverageListServer) Send(m *CoverageArea) error {
	return x.ServerStream.SendMsg(m)
}

func _Coverage_Get_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CoverageArea)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CoverageServer).Get(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Coverage/Get",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CoverageServer).Get(ctx, req.(*CoverageArea))
	}
	return interceptor(ctx, in, info, handler)
}

func _Coverage_Update_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(CoverageArea)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(CoverageServer).Update(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: "/com.freeje.api.admin.Coverage/Update",
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(CoverageServer).Update(ctx, req.(*CoverageArea))
	}
	return interceptor(ctx, in, info, handler)
}

// Coverage_ServiceDesc is the grpc.ServiceDesc for Coverage service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Coverage_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "com.freeje.api.admin.Coverage",
	HandlerType: (*CoverageServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Get",
			Handler:    _Coverage_Get_Handler,
		},
		{
			MethodName: "Update",
			Handler:    _Coverage_Update_Handler,
		},
	},
	Streams: []grpc.StreamDesc{
		{
			StreamName:    "List",
			Handler:       _Coverage_List_Handler,
			ServerStreams: true,
		},
	},
	Metadata: "admin/coverage.proto",
}
